﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
' Events declaration
#Event: 

' Class module

Sub Class_Globals
  Private mTarget As Object
  Private mEventName As String
  
  Private lblSeek As Label
  Private lstSeek As List
  Private lblText As String
  
  Private sbSeek As SeekBar
  
  Public mBase As Panel
End Sub

' ComboBox consists of edittext, drop button

Public Sub Initialize (TargetModule As Object, EventName As String)
  mTarget = TargetModule
  mEventName = EventName
End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, Props As Map)
  mBase = Base
  mBase.Color = Colors.LightGray
  
  Dim pnl As Panel
  
  pnl.Initialize("")
  pnl.Color = Colors.White
  mBase.AddView(pnl, 1dip, 1dip, mBase.Width - 2dip, mBase.Height - 2dip)
  
  lstSeek.Initialize
  lblText = lbl.Text
  
  lblSeek.Initialize("")
  lblSeek.TextColor = Colors.Black
  lblSeek.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)
  lblSeek.Text = lblText
  
  pnl.AddView(lblSeek, 0, 0, pnl.width * 0.20, pnl.height)
  
  sbSeek.Initialize("sbSeek")
  sbSeek.Max = 100

  pnl.AddView(sbSeek, lblSeek.width, (pnl.Height - 30dip) / 2, pnl.width - lblSeek.width - 2dip, 30dip)
End Sub

Private Sub sbSeek_ValueChanged(Value As Int, UserChanged As Boolean)
  If ((lstSeek.Size < 1) OR (Value >= lstSeek.Size)) Then Return
  
  Dim v As String = lstSeek.Get(Value)
  
  SetLabel(lblText & CRLF & v)
  If SubExists(mTarget, "LBSChanged") Then CallSub2(mTarget, "LBSChanged", v)
End Sub
    
Public Sub AddList(lst As List)
  If (lst.Size > 0) Then
    For i=0 To lst.Size-1
      lstSeek.Add((lst.Get(i)))
    Next
  
    sbSeek.Max = lstSeek.Size - 1
    SetLabel(lstSeek.Get(0))
  Else
    Clear
    SetLabel("")
  End If
End Sub

Public Sub Clear
  lstSeek.Clear
End Sub

Public Sub SetLabel(s As String)
  lblSeek.Text = s
End Sub

Public Sub SetValue(n)
  sbSeek.Value = n
End Sub

Public Sub SetItmVal(itm As String)
  Dim i As Int = lstSeek.IndexOf(itm)
  
  If (i < 0) Then
    SetValue(0)
  Else
    SetValue(i)
  End If
End Sub
